#include "Ventil.hpp"	//Einbinden der Ventilheader
class Schokidrucker{

  private:
    //Position
    float X_aktuell;	//Gibt die aktuelle X-Position an 
    float Y_aktuell;	//Gibt die aktuelle Y-Position an
    float X_Start;		//Gibt die Start X-Position an
    float Y_Start;		//Gibt die Start Y-Position an

    //Stepper
    int X_Richtung;	//1 für positiv, -1 für negativ
    int Y_Richtung; //1 für positiv, -1 für negativ
    int Grunddelay; //Grunddelay der Stepper, hiermit kann die Geschwindigkeit eingestellt werden
    int X_Stepper_Pin;		//Pinvariablen...(selbsterklärend)
    int Y_Stepper_Pin;
    int X_Richtung_Pin;
    int Y_Richtung_Pin;
    int Pixelumrechnung;	//Angabe, wieviele Steps einer LAENGENEINHEIT entsprechen (106 Steps == 1cm)

    //Spritze
    int Spritze_Geschwindigkeit;	//Geschwindigkeit des Linearmotors (0-128)
    int Spritze_Richtung;	//-1 = Hoch, 1 = Runter
    int Spritze_Pin_Hoch;	//Pinvariablen...(selbsterklärend)
    int Spritze_Pin_Runter;
    int Spritze_Pin_Geschwindigkeit;
    int Druck;	//Standardgeschwindigkeit die beim Drucken verwendet werden soll (bei uns 50)

    //Motor
    int Motor_Pin;	//Pinnummer für den Motor mit Milchschäumer

    //Ventil
    Ventil v;	//erstellen eines Ventilobjekts

    public:
      //Konstruktor
      Schokidrucker(int x, int y, int Xpin, int Ypin, int XrP, int YrP, int pixel, int SpH, int SpR, int SpG); //erstellt ein Schokidruckerobjekt

      //Geter und Seter
      int GetX(); //Gibt X-Position
      int GetY();	//Gibt Y-Position
      int GetStartX();	//Gibt Start X-Position
      int GetStartY();	//Gibt Start Y-Position
      void SetStartX(int x);	//Setzt X-Startposition auf x (falls beispielsweise ein Bild nicht bei der Position 0,0 anfangen soll.)
      void SetStartY(int y);	//Das selbe mit Y
      void StartingPosition(int x, int y); //Setzt Startpostition neu und nimmt diese auch gleich als aktuelle Position an
      void Calibrate(int x, int y);	//macht das selbe wie SetStartX/Y()
      void SetDelay(int d);		//Setzt den Grunddelay
      int GetDelay();	//Gibt Grunddelay
      int GetXPin();	//Gibt X_Stepper_Pin zurück
      int GetYPin();	//Gibt Y_Stepper_Pin zurück
      int GetXRPin();	//Gibt X_Richtung_Pin zurück
      int GetYRPin();	//Gibt Y_Richtung_Pin zurück
      void SetXPin(int pin); 	//Setermethoden für oben genannte
      void SetYPin(int pin);
      void SetXRPin(int pin);
      void SetYRPin(int pin);
      void SetXRichtung(int r);
      void SetYRichtung(int r);
      int GetXRichtung();	//Gibt Richtung zurück (-1 == negativ, 1 == positiv)...
      int GetYRichtung();
      int GetPixel();	//Gibt Umrechnungsrate zurück (siehe Oben)
      void SetPixel(int p);	//Setzt Umrechnungsrate

      int SpritzeGetSpeed();	//Gibt Geschwindigkeit der Spritze
      void SpritzeSetSpeed(int v); //Setzt Geschwindigkeit der Spritze auf v
      int SpritzeGetRichtung();
      void SpritzeSetRichtung(int r);	//Setzt Richtung (-1 = hoch, 1 = runter, 0 = stehen bleiben)
      int SpritzeGetPinHoch();	//Seter und Geter der Pins für die Spritze
      void SpritzeSetPinHoch(int pin);
      int SpritzeGetPinRunter();
      void SpritzeSetPinRunter(int pin);
      int GetDruck();	//Gibt die Druckgeschwindigkeit
      void SetDruck(int d);	//Setzt die Druckgeschwindigkeit

      int Motor(int p); //Setzt Pin des Motors

      void SetVentilServo(Servo *s); //Setzt den Servo des Ventils (Adresse von Servo-Objekt muss uebergeben werden
      

      //Befehle
      void Goto(int x, int y); //Laesst ihnn erst vollstaendig in X-Richtung und dann in Y-Richtung wandern zu dem entsprechenden Punkt
      void MakeLine(float x, float y); //Zeichnet eine Linie
      void Print(float x[], float y[], int laenge, int anzahl); //Zeichnet nacheinander Linien zu den Punkten der arrays
      void SchokoLos(); //Spritze drueckt
      void SchokoStop(); //Spritze zieht kurz raus und haelt an
      void Stop(); //Stoppt die Anlage
      void FullStop(); //Zieht Spritze kurz raus und stoppt dann die Anlage
      void End();	//beendet den Loop
      void StartingPosition(); //faehrt zur Startposition

      void SpritzeStop();	//Stoppt die Spritze
      void SpritzeHoch(int v); //Faehrt die Spritze mit Geschwindigkeit V hoch
      void SpritzeRunter(int v);  //Faehrt die Spritze mit Geschwindigkeit V runter
      void SpritzeMove(); //laesst die Spritze mit vorher gesetzten Werten bewegen

      void MotorOn(); //Schaltet den Ruehrmotor ein
      void MotorOff(); //Schaltet den Ruehrmotor aus

      void VentilAuf();	//Macht das Ventil auf
      void VentilZu();	//Macht das Ventil zu
       
};
//Definition der Methoden
//Konstruktor: setzen der eigegebenen Variablen (siehe Klassenbeschreibungsblatt)
Schokidrucker::Schokidrucker(int x, int y, int Xpin, int Ypin, int XrP, int YrP, int pixel, int SpH, int SpR, int SpG){
  //Position
    X_aktuell = x;
    Y_aktuell = y;
    X_Start = x;
    Y_Start = y;

    //Stepper
    X_Richtung = 1;
    Y_Richtung = 1;
    Grunddelay = 1000;
    X_Stepper_Pin = Xpin;
    Y_Stepper_Pin = Ypin;
    X_Richtung_Pin = XrP;
    Y_Richtung_Pin = YrP;
    Pixelumrechnung = pixel;

    //Spritze
    Spritze_Geschwindigkeit = 0;
    Spritze_Richtung = -1;
    Spritze_Pin_Hoch = SpH;
    Spritze_Pin_Runter = SpR;
    Spritze_Pin_Geschwindigkeit = SpG;
    Druck = 50;

    pinMode(X_Stepper_Pin,OUTPUT);
    pinMode(Y_Stepper_Pin,OUTPUT);
    pinMode(X_Richtung_Pin,OUTPUT);
    pinMode(Y_Richtung_Pin,OUTPUT);
    pinMode(Spritze_Pin_Hoch,OUTPUT);
    pinMode(Spritze_Pin_Runter,OUTPUT);
    pinMode(Spritze_Pin_Geschwindigkeit,OUTPUT);
  
}

//Definition der Methoden
int Schokidrucker::GetX(){
  return X_aktuell;
}
int Schokidrucker::GetY(){
  return Y_aktuell;
}
int Schokidrucker::GetStartX(){
  return X_Start;
}
int Schokidrucker::GetStartY(){
  return Y_Start;
}
void Schokidrucker::SetStartX(int x){
  X_Start = x;
}
void Schokidrucker::SetStartY(int y){
  Y_Start = y;
}
void Schokidrucker::StartingPosition(int x, int y){
  X_aktuell = x;
  Y_aktuell = y;
  X_Start = x;
  Y_Start = y;
}
void Schokidrucker::Calibrate(int x, int y){
  X_aktuell = x;
  Y_aktuell = y;
}
void Schokidrucker::SetDelay(int d){
  Grunddelay = d;
}
int Schokidrucker::GetDelay(){
  return Grunddelay;
}
int Schokidrucker::GetXPin(){
  return X_Stepper_Pin;
}
int Schokidrucker::GetYPin(){
  return Y_Stepper_Pin;
}
int Schokidrucker::GetXRPin(){
  return X_Richtung_Pin;
}
int Schokidrucker::GetYRPin(){
  return Y_Richtung_Pin;
}
void Schokidrucker::SetXPin(int pin){
  X_Stepper_Pin = pin;
}
void Schokidrucker::SetYPin(int pin){
  Y_Stepper_Pin = pin;
}
void Schokidrucker::SetXRPin(int pin){
  X_Richtung_Pin = pin;
}
void Schokidrucker::SetYRPin(int pin){
  Y_Richtung_Pin = pin;
}
void Schokidrucker::SetXRichtung(int r){
  if(r<0){
    X_Richtung = -1;
    digitalWrite(X_Richtung_Pin, LOW);
  }
  else{
    X_Richtung = 1;
    digitalWrite(X_Richtung_Pin, HIGH);
  }
}

void Schokidrucker::SetYRichtung(int r){
  if(r<0){
    Y_Richtung = -1;
    digitalWrite(Y_Richtung_Pin, LOW);
  }
  else{
    Y_Richtung = 1;
    digitalWrite(Y_Richtung_Pin, HIGH);
  }
}

int Schokidrucker::GetXRichtung(){
  return X_Richtung;
}

int Schokidrucker::GetYRichtung(){
  return Y_Richtung;
}

int Schokidrucker::GetPixel(){
  return Pixelumrechnung;
}

void Schokidrucker::SetPixel(int p){
  Pixelumrechnung = p;
}

int Schokidrucker::SpritzeGetSpeed(){
  return Spritze_Geschwindigkeit;
}

void Schokidrucker::SpritzeSetSpeed(int v){
  Spritze_Geschwindigkeit = v;
}
int Schokidrucker::SpritzeGetRichtung(){
  return Spritze_Richtung;
}

void Schokidrucker::SpritzeSetRichtung(int r){
  if(r<0){
    Spritze_Richtung = -1;
    digitalWrite(Spritze_Pin_Hoch, HIGH);
    digitalWrite(Spritze_Pin_Runter, LOW);
  }
  if(r==0){
    Spritze_Richtung = 0;
    digitalWrite(Spritze_Pin_Hoch, LOW);
    digitalWrite(Spritze_Pin_Runter, LOW);
  }
  else{
    Spritze_Richtung = 1;
    digitalWrite(Spritze_Pin_Hoch, LOW);
    digitalWrite(Spritze_Pin_Runter, HIGH);
  }
}

int Schokidrucker::SpritzeGetPinHoch(){
  return Spritze_Pin_Hoch;
}

void Schokidrucker::SpritzeSetPinHoch(int pin){
  Spritze_Pin_Hoch = pin;
}
      
int Schokidrucker::SpritzeGetPinRunter(){
  return Spritze_Pin_Runter;
}

void Schokidrucker::SpritzeSetPinRunter(int pin){
  Spritze_Pin_Runter = pin;
}

int Schokidrucker::GetDruck(){
  return Druck;
}
void Schokidrucker::SetDruck(int d){
  Druck = d;
}

int Schokidrucker::Motor(int p){
  pinMode(p,OUTPUT);
  Motor_Pin = p;
}

void Schokidrucker::SetVentilServo(Servo *s){
  v.SetServo(s);
}


//Goto Befehl:
void Schokidrucker::Goto(int x, int y){
  int wegX = x-X_aktuell; //herrausfinden der Strecke in X-Richtung
  int wegY = y-Y_aktuell; //herrausfinden der Strecke in Y-Richtung
  
  //Entfernen des Vorzeichens und merken ob positiv oder negativ:
  if(wegX<0){
    digitalWrite(X_Richtung_Pin, LOW);
    wegX = wegX*(-1);
  }
  else{
    digitalWrite(X_Richtung_Pin, HIGH);
  }

  if(wegY<0){
    digitalWrite(Y_Richtung_Pin, LOW);
    wegY = wegY*(-1);
  }
  else{
    digitalWrite(Y_Richtung_Pin, HIGH);
  }

//Strecke in X-Richtung gehen:
  for (int i = 0; i < Pixelumrechnung*wegX; i++){
        digitalWrite(X_Stepper_Pin, HIGH);
        delayMicroseconds(Grunddelay);
        digitalWrite(X_Stepper_Pin, LOW);
        delayMicroseconds(Grunddelay);
  }
 //Strecke in Y-Richtung gehen
  for (int i = 0; i < Pixelumrechnung*wegY; i++){
        digitalWrite(Y_Stepper_Pin, HIGH);
        delayMicroseconds(Grunddelay);
        digitalWrite(Y_Stepper_Pin, LOW);
        delayMicroseconds(Grunddelay);
  }
  //Aktuelle Position setzen
  X_aktuell = x;
  Y_aktuell = y;
}


//MakeLine Befehl:
void Schokidrucker::MakeLine(float x, float y){
  //Berechnen der zurueckzulegenen Strecken in X und Y-Richtung
  float strecke_X = x - X_aktuell;  
  float strecke_Y = y - Y_aktuell;  
  float Intervall_X;  
  float Intervall_Y;  

  //Entfernen der Vorzeichen und merken ob positiv oder negativ
  if (strecke_X < 0) {
    digitalWrite(X_Richtung_Pin, LOW); 
    strecke_X = strecke_X * (-1);
  }
  else {
    digitalWrite(X_Richtung_Pin, HIGH);
  }

  if (strecke_Y < 0) {
    digitalWrite(Y_Richtung_Pin, LOW);
    strecke_Y = strecke_Y * (-1);
  }
  else {
    digitalWrite(Y_Richtung_Pin, HIGH);
  }
 //anpassen der Wartezeiten zwischen Steps im Verhaeltnis der Strecken
  if (strecke_X > strecke_Y) {
    Intervall_X = Grunddelay;  
    Intervall_Y = Grunddelay * (strecke_X / strecke_Y); 
  }
  else {
    Intervall_Y = Grunddelay; 
    Intervall_X = Grunddelay * (strecke_Y / strecke_X);
  }

  unsigned long zeit_vorher_X = 0;
  bool modus_X = false;
  unsigned long zeit_vorher_Y = 0;
  bool modus_Y = false;
  int zaehlerX = 0;
  int zaehlerY = 0;

  unsigned long Zeit_aktuell = micros();
  zeit_vorher_X = Zeit_aktuell;
  zeit_vorher_Y = Zeit_aktuell;

  //Strecke fahren: Immer wenn die Zeit seit dem letzten Step laenger/gleich dem Intervall ist ==> naechster Step
  while (zaehlerX < strecke_X * Pixelumrechnung || zaehlerY < strecke_Y * Pixelumrechnung) {
    Zeit_aktuell = micros();

    if (Zeit_aktuell - zeit_vorher_X >= Intervall_X) {
      zeit_vorher_X = Zeit_aktuell;
      
      if (modus_X == false) {
        digitalWrite(X_Stepper_Pin, HIGH);
        modus_X = true;
      }

      else {
        digitalWrite(X_Stepper_Pin, LOW);
        modus_X = false;
        zaehlerX++;
      }
    }

    if (Zeit_aktuell - zeit_vorher_Y >= Intervall_Y) {
      zeit_vorher_Y = Zeit_aktuell;
      
      if (modus_Y == false) {
        digitalWrite(Y_Stepper_Pin, HIGH);
        modus_Y = true;
      }
      else {
        digitalWrite(Y_Stepper_Pin, LOW);
        modus_Y = false;
        zaehlerY++;
      }
    }

    
  }
//Aktuelle Position setzen
  X_aktuell = x;
  Y_aktuell = y;
}

//Print Befehl (aneinanderreihen von MakeLine
void Schokidrucker::Print(float x[], float y[], int laenge, int anzahl){
  SchokoLos();
  for(int a = 0; a<anzahl; a++){
    for(int i = 0; i<laenge; i++){
     MakeLine(x[i],y[i]);
    }
  }
  FullStop();
}

void Schokidrucker::SchokoLos(){
  digitalWrite(Spritze_Pin_Hoch, LOW);
  digitalWrite(Spritze_Pin_Runter, HIGH);
  analogWrite(Spritze_Pin_Geschwindigkeit, Druck);
}

void Schokidrucker::SchokoStop(){
  digitalWrite(Spritze_Pin_Hoch, HIGH);
  digitalWrite(Spritze_Pin_Runter, LOW);
  analogWrite(Spritze_Pin_Geschwindigkeit, 128);
  delay(2500);
  SpritzeStop();
}

void Schokidrucker::Stop(){
  digitalWrite(Spritze_Pin_Hoch, LOW);
  digitalWrite(Spritze_Pin_Runter, LOW);
  analogWrite(Spritze_Pin_Geschwindigkeit, 0);
  digitalWrite(X_Stepper_Pin, LOW);
  digitalWrite(Y_Stepper_Pin, LOW);
}

void Schokidrucker::FullStop(){
  digitalWrite(X_Stepper_Pin, LOW);
  digitalWrite(Y_Stepper_Pin, LOW);
  digitalWrite(Spritze_Pin_Hoch, HIGH);
  digitalWrite(Spritze_Pin_Runter, LOW);
  analogWrite(Spritze_Pin_Geschwindigkeit, 128);
  delay(2500);
  SpritzeStop();
}

void Schokidrucker::End(){
  digitalWrite(X_Stepper_Pin, LOW);
  digitalWrite(Y_Stepper_Pin, LOW);
  digitalWrite(Spritze_Pin_Hoch, LOW);
  digitalWrite(Spritze_Pin_Runter, LOW);
  analogWrite(Spritze_Pin_Geschwindigkeit, 0);
  while(true){
    delay(1000);
  }
}

void Schokidrucker::StartingPosition(){
  Goto(X_Start,Y_Start);
}

void Schokidrucker::SpritzeStop(){
  digitalWrite(Spritze_Pin_Hoch, LOW);
  digitalWrite(Spritze_Pin_Runter, LOW);
  analogWrite(Spritze_Pin_Geschwindigkeit, 0);
}

void Schokidrucker::SpritzeHoch(int v){
  digitalWrite(Spritze_Pin_Hoch, HIGH);
  digitalWrite(Spritze_Pin_Runter, LOW);
  analogWrite(Spritze_Pin_Geschwindigkeit, v);
}

void Schokidrucker::SpritzeRunter(int v){
  digitalWrite(Spritze_Pin_Hoch, LOW);
  digitalWrite(Spritze_Pin_Runter, HIGH);
  analogWrite(Spritze_Pin_Geschwindigkeit, v);
}

void Schokidrucker::SpritzeMove(){
  analogWrite(Spritze_Pin_Geschwindigkeit, Spritze_Geschwindigkeit);
}

void Schokidrucker::MotorOn(){
  digitalWrite(Motor_Pin,HIGH);
}

void Schokidrucker::MotorOff(){
  digitalWrite(Motor_Pin,LOW);
}

void Schokidrucker::VentilAuf(){
//Zugriff ueber Ventilobjekt
  v.AUF();
}

void Schokidrucker::VentilZu(){
  v.ZU();
}